HDU 1043 Eight

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1043

Eight

Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 13317    Accepted Submission(s): 3793
Special Judge


Problem Description
The 15-puzzle has been around for over 100 years; even if you don't know it by that name, you've seen it. It is constructed with 15 sliding tiles, each with a number from 1 to 15 on it, and all packed into a 4 by 4 frame with one tile missing. Let's call the missing tile 'x'; the object of the puzzle is to arrange the tiles so that they are ordered as:
 1  2  3  4
 5  6  7  8
 9 10 11 12
13 14 15  x

where the only legal operation is to exchange 'x' with one of the tiles with which it shares an edge. As an example, the following sequence of moves solves a slightly scrambled puzzle:
 1  2  3  4     1  2  3  4     1  2  3  4     1  2  3  4
 5  6  7  8     5  6  7  8     5  6  7  8     5  6  7  8
 9  x 10 12     9 10  x 12     9 10 11 12     9 10 11 12
13 14 11 15    13 14 11 15    13 14  x 15    13 14 15  x
            r->            d->            r->

The letters in the previous row indicate which neighbor of the 'x' tile is swapped with the 'x' tile at each step; legal values are 'r','l','u' and 'd', for right, left, up, and down, respectively.

Not all puzzles can be solved; in 1870, a man named Sam Loyd was famous for distributing an unsolvable version of the puzzle, and
frustrating many people. In fact, all you have to do to make a regular puzzle into an unsolvable one is to swap two tiles (not counting the missing 'x' tile, of course).

In this problem, you will write a program for solving the less well-known 8-puzzle, composed of tiles on a three by three
arrangement.
 

Input
You will receive, several descriptions of configuration of the 8 puzzle. One description is just a list of the tiles in their initial positions, with the rows listed from top to bottom, and the tiles listed from left to right within a row, where the tiles are represented by numbers 1 to 8, plus 'x'. For example, this puzzle

1 2 3
x 4 6
7 5 8

is described by this list:

1 2 3 x 4 6 7 5 8
 

Output
You will print to standard output either the word ``unsolvable'', if the puzzle has no solution, or a string consisting entirely of the letters 'r', 'l', 'u' and 'd' that describes a series of moves that produce a solution. The string should include no spaces and start at the beginning of the line. Do not print a blank line between cases.
 

Sample Input
  
  
2 3 4 1 5 x 7 6 8
 

Sample Output
  
  
ullddrurdllurdruldr
此题是经典的八数码问题。

由于数据量较大我们可以打表。那如何打表呢?

我们可以从终态出发,利用BFS来搜出每一个能从终态到达的状态即可。

注意,由于我们最后要的是始态到终态的路径,那我们构造路径的时候就要格外小心,注意反向和正向的区别。

接下来的一个很重要的问题就是状态如何标记。由于我们用的是字符串作为状态,一种办法是利用康拓展开来标记,一种是直接利用STL的map标记。我这里用的是map。

AC代码如下。

#include<iostream>
#include<queue>
#include<cstring>
#include<cstdio>
#include<map>
using namespace std;
struct node
{
    int pos;//空格所在位置
    string s;//当前状态
    string p;//路径
};
int n,sx,sy,ex,ey;
int dir[][2]={ {0,1},{-1,0},{0,-1},{1,0} };
//                  right up    left    down
string dirs="ldru";//方向数组
string start="12345678x",en;
map<string,string>mp;
void bfs()
{
    queue<node>q;
    node now,next;
    now.pos=start.find('x');
    now.s=start;now.p="";
    q.push(now);
    mp[start]="";
    while(q.size())
    {
        now=q.front();q.pop();
        int x=now.pos/3,y=now.pos%3;
        for(int i=0;i<4;i++)
        {
            int nx=x+dir[i][0],ny=y+dir[i][1];
            if(0<=nx&&nx<3&&0<=ny&&ny<3)
            {
                int pos=nx*3+ny;
                next.s=now.s;
                swap(next.s[pos],next.s[now.pos]);
                if(mp.find(next.s)==mp.end())
                {
                    next.pos=pos;
                    next.p=dirs[i]+now.p;
                    mp[next.s]=next.p;
                    q.push(next);
                }
            }
        }
    }
}
int main()
{
    char c;
    cin.sync_with_stdio(false);
    bfs();
    while(cin>>c)
    {
        en=c;
        for(int i=1;i<=8;i++) cin>>c,en+=c;
        if(mp.find(en)==mp.end()) cout<<"unsolvable"<<endl;
        else cout<<mp[en]<<endl;
    }
    return 0;
}


评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值